#include <Adafruit_NeoPixel.h>

#define CONTROL        0
#define BLOCKLY        1


#define ALIVE          0
#define VIBE           1


#define GET            1
#define SET            2
#define RESET          3


#define PIN_LEFT_MOTOR_FW      2
#define PIN_LEFT_MOTOR_BW      4
#define PIN_RIGHT_MOTOR_FW     8
#define PIN_RIGHT_MOTOR_BW     7


#define PIN_LED               11


#define PIN_BUZZER             3

#define PIN_VIBE              A0


#define PIN_GEAR_MOTOR_FW      9
#define PIN_GEAR_MOTOR_BW     10


#define PIN_ANGLE_MOTOR_FW     6
#define PIN_ANGLE_MOTOR_BW     5


#define PIN_NEOPIXEL          12
#define NEOPIXEL_NUM          18

const int BEFORE_NEOPIXEL_NUM = 36;

Adafruit_NeoPixel pixels(BEFORE_NEOPIXEL_NUM, PIN_NEOPIXEL, NEO_GRB + NEO_KHZ800);

int mode             = 0;
int life             = 3;
int shootMotorState  = 0;


int GEAR_MAX_SPEED = 200;
int GEAR_MIN_SPEED = 0;
int GEAR_CATCH_SPEED = 80;


int ANGLE_MAX_SPEED = 220;
int ANGLE_MIN_SPEED = 0;

union {
  byte byteVal[4];
  float floatVal;
  long longVal;
} val;

union {
  byte byteVal[2];
  short shortVal;
} valShort;

const int START_VAL = 255;
const int DATA_LEN = 68; // 기존 14
const int END_VALUE = 10;

int beforeBuzNote = 0;
int rotation = 1000;

unsigned char buf[DATA_LEN];
unsigned char prevc=0;
int index = 0;
boolean isStart = false;

int vibeState = 0;
boolean isReload = false;

// Add 24.08.22
int prevRedList[NEOPIXEL_NUM];
int prevGreenList[NEOPIXEL_NUM];
int prevBlueList[NEOPIXEL_NUM];

int redList[NEOPIXEL_NUM];
int greenList[NEOPIXEL_NUM];
int blueList[NEOPIXEL_NUM];

void initPorts() {
  for (int i=2; i < 14; i++) {
    pinMode(i, OUTPUT);
    digitalWrite(i, LOW);
  }
}