#include "initial.h"

void updateDigitalPort(unsigned char c) {
  if (c == DATA_LEN && isStart == false) {
    if (prevc == START_VAL) {
      isStart = true;
      index = 1;
      writeBuffer(index-1, prevc);
      writeBuffer(index, c);
    }
  } else {
    prevc = c;
    if (isStart) {
      writeBuffer(index, c);
    }
  }

  index++;
  
  if (index > DATA_LEN) {
    isStart = false;
    index = 0;
  }

  if (isStart && index == DATA_LEN && index > 3) {
    isStart = false;
    parseData();
    index = 0;
  }
}

boolean isCheckOk () {
  if (buf[DATA_LEN-1] == END_VALUE) {
    int checkSum = buf[DATA_LEN-2];
    int sumValue = 0;
    for (int i=2; i < DATA_LEN-2; i++) {
      sumValue += buf[i];
    }
    sumValue = sumValue & 0xff;
    if (checkSum == sumValue) {
      return true;
    }
  }
  return false;
}

unsigned char readBuffer(int index) {
  return buf[index];
}

void buzCtrl(int buzOctave, int buzNote) {
  int note = (buzOctave << 8) + buzNote;
  if (beforeBuzNote != note) {
    beforeBuzNote = note;
    if (note > 30) {
      tone(PIN_BUZZER, note);
    } else {
      noTone(PIN_BUZZER);
    }
  }
}

void motorCtrl(int motorState) {
  switch(motorState) {
    case 0: //Stop
      digitalWrite(PIN_RIGHT_MOTOR_FW, LOW);
      digitalWrite(PIN_RIGHT_MOTOR_BW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_FW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_BW, LOW);
      break;
    case 1: // Forward
      digitalWrite(PIN_RIGHT_MOTOR_FW, HIGH);
      digitalWrite(PIN_RIGHT_MOTOR_BW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_FW, HIGH);
      digitalWrite(PIN_LEFT_MOTOR_BW, LOW);
      break;
    case 2: // Turn Left
      digitalWrite(PIN_RIGHT_MOTOR_FW, HIGH);
      digitalWrite(PIN_RIGHT_MOTOR_BW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_FW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_BW, HIGH);
      break;
    case 3: // Turn Right
      digitalWrite(PIN_RIGHT_MOTOR_FW, LOW);
      digitalWrite(PIN_RIGHT_MOTOR_BW, HIGH);
      digitalWrite(PIN_LEFT_MOTOR_FW, HIGH);
      digitalWrite(PIN_LEFT_MOTOR_BW, LOW);
      break;
    case 4: // Backward
      digitalWrite(PIN_RIGHT_MOTOR_FW, LOW);
      digitalWrite(PIN_RIGHT_MOTOR_BW, HIGH);
      digitalWrite(PIN_LEFT_MOTOR_FW, LOW);
      digitalWrite(PIN_LEFT_MOTOR_BW, HIGH);
      break;
  }
}

void ledCtrl(int ledPin, int ledValue) {
  if (ledValue == 255) {
    digitalWrite(ledPin, HIGH);
  } else if (ledValue == 0) {
    digitalWrite(ledPin, LOW);
  } else {
    analogWrite(ledPin, ledValue);
  }
}

void controlShootMotorCtrl() {
  
  if (shootMotorState == 2) {
    
    shootMotorCtrl(shootMotorState);
    delay(2000);
  }
  
  if (shootMotorState == 0 && life == 3) {
    energyExpress(life);
  }
  
  while (shootMotorState == 2 && life > 0) {
  
    int vibe_value =  analogRead(PIN_VIBE);
    if (vibe_value > 600) {
   
      pixels.clear();
      theaterChase(pixels.Color(40, 40, 40), 10);
      writeValue(0xff);
      writeValue(0x7);
      writeValue(VIBE);
      writeValue(1); 
      writeValue(--life);
      int checkSum = 0;
      checkSum = (VIBE + 1 + life) & 0xff;
      writeValue(checkSum);
      writeEnd();
       

      for(int i=0; i < 2; i++) {
        tone(PIN_BUZZER, 194, 100);
        delay(150);
        tone(PIN_BUZZER, 212, 100);
        delay(150);
      }

      delay(400);

      if (life == 0) {

          colorWipe(pixels.Color(40, 0, 40), 10); // Red
          tone(PIN_BUZZER, 1046, 80);
          colorWipe(pixels.Color(0, 40, 40), 10); // Green
          tone(PIN_BUZZER, 784, 80);
          colorWipe(pixels.Color(0, 0, 0), 10); // Blue
          tone(PIN_BUZZER, 659, 80);  
          theaterChase(pixels.Color(40, 40, 0), 10); // White
          tone(PIN_BUZZER, 523, 1000);
          delay(1000);
          pixels.clear();
          pixels.show();

           
          for(int i=0; i < 10; i++) {
          tone(PIN_BUZZER, 33, 300);
          delay(350);
     
        }
        life -= 1;
      } else if (life <= 3 && life > 0) {
        energyExpress(life); 
      }
    }
    
    bluetooth_read();
  }
  
  if (shootMotorState != 2) {
    shootMotorCtrl(shootMotorState);
  }
}

void shootMotorCtrl(int shootMotorState) {
  if (shootMotorState == 0) { // 정지
    analogWrite(PIN_GEAR_MOTOR_FW, GEAR_MIN_SPEED);
    analogWrite(PIN_GEAR_MOTOR_BW, GEAR_MIN_SPEED);
  } else if (shootMotorState == 1) { 
    isReload = true;
    analogWrite(PIN_GEAR_MOTOR_FW, GEAR_MAX_SPEED);
    analogWrite(PIN_GEAR_MOTOR_BW, GEAR_MIN_SPEED);
  } else if (shootMotorState == 2) { 
    if (isReload) {
      analogWrite(PIN_GEAR_MOTOR_FW, GEAR_MIN_SPEED);
      analogWrite(PIN_GEAR_MOTOR_BW, GEAR_MAX_SPEED);
      delay(80);
      isReload = false;
    }
    analogWrite(PIN_GEAR_MOTOR_FW, GEAR_MIN_SPEED);
    analogWrite(PIN_GEAR_MOTOR_BW, GEAR_MIN_SPEED);
  } else if (shootMotorState == 3) { 
    analogWrite(PIN_GEAR_MOTOR_FW, GEAR_CATCH_SPEED);
    analogWrite(PIN_GEAR_MOTOR_BW, GEAR_MIN_SPEED);
  }
}

void angleMotorCtrl(int angleMotorState) {
  if (angleMotorState == 1) { 
    analogWrite(PIN_ANGLE_MOTOR_FW, ANGLE_MAX_SPEED);
    analogWrite(PIN_ANGLE_MOTOR_BW, ANGLE_MIN_SPEED);
  } else if (angleMotorState == 2) { 
    analogWrite(PIN_ANGLE_MOTOR_FW, ANGLE_MIN_SPEED);
    analogWrite(PIN_ANGLE_MOTOR_BW, ANGLE_MAX_SPEED);
  } else { // 정지
    digitalWrite(PIN_ANGLE_MOTOR_FW, ANGLE_MIN_SPEED);
    digitalWrite(PIN_ANGLE_MOTOR_BW, ANGLE_MIN_SPEED);
  }
}

void parseData() {
  if (isCheckOk()) {
    mode = readBuffer(2);
    life = readBuffer(3);
    int buzOctave = readBuffer(4);
    int buzNote = readBuffer(5);
    int motorState = readBuffer(6);
    int ledValue = readBuffer(7);
    shootMotorState = readBuffer(8);
    int d9Value = readBuffer(9);
    int d10Value = readBuffer(10);
    int angleMotorState = readBuffer(11);

    for (int i=0; i < NEOPIXEL_NUM; i++) {
      redList[i] = readBuffer(3*i+12);
      greenList[i] = readBuffer(3*i+13);
      blueList[i] = readBuffer(3*i+14);
    }
    
    buzCtrl(buzOctave, buzNote);
    motorCtrl(motorState);
    ledCtrl(PIN_LED, ledValue);

    if (mode == 0) {
      controlShootMotorCtrl();
    } else {
      if (shootMotorState == 4) {
        ledCtrl(PIN_GEAR_MOTOR_FW, d9Value);
        ledCtrl(PIN_GEAR_MOTOR_BW, d10Value);
      } else {
      shootMotorCtrl(shootMotorState);
      }
      neopixelCtrl(redList, greenList, blueList);
    }

    angleMotorCtrl(angleMotorState);
  }
}

void getVibeValue() {
  writeValue(0xff);
  writeValue(0x7);
  writeValue(VIBE);
  int vibeValue = analogRead(PIN_VIBE);
  if (vibeValue > 600) {
    vibeState = 1;
  } else {
    vibeState = 0;
  }
  writeValue(vibeState);
  writeValue(life);
  int checkSum = 0;
  checkSum = (VIBE + vibeState + life) & 0xff;
  writeValue(checkSum);
  writeEnd();
}

void sendSensorValues() {
  getVibeValue();
}

void writeBuffer(int index, unsigned char c) {
  buf[index] = c;
}

void writeValue(unsigned char c) {
  Serial.write(c);
}

void writeEnd() {
  Serial.write(0xd);
  Serial.write(0xa);
}

void sendFloat(float value) {
  val.floatVal = value;
  writeValue(val.byteVal[0]);
  writeValue(val.byteVal[1]);
  writeValue(val.byteVal[2]);
  writeValue(val.byteVal[3]);
}

void bluetooth_read() {
  while (Serial.available()) {
    unsigned char c = Serial.read();
    updateDigitalPort(c);
  }
}

void setup() {
  initPorts();
  Serial.begin(115200);

  initNeoPixel();

  colorWipe(pixels.Color(40, 0, 0), 10);
  tone(PIN_BUZZER, 523, 40);
  delay(50);
  tone(PIN_BUZZER, 523, 40);
  colorWipe(pixels.Color(0, 40, 0), 10); 
  tone(PIN_BUZZER, 659, 40);
  delay(50);
  tone(PIN_BUZZER, 659, 40);
  colorWipe(pixels.Color(0, 0, 40), 10); 
  tone(PIN_BUZZER, 784, 40);
  delay(50);  
  tone(PIN_BUZZER, 784, 40); 
  theaterChase(pixels.Color(40, 40, 40), 10); 
  tone(PIN_BUZZER, 1046, 1000);
  delay(1000);

  for(int i=0;i<4;i++){
   energyExpress(life);
   delay(300);
   pixels.clear();
   pixels.show();
   delay(300);
  }
}

void loop() {
  bluetooth_read();

  if (mode == 1) {
    if(rotation > 1000) {
      rotation = 0;
      sendSensorValues();
    }
    rotation++;
  }
}

void callOK() {
  writeValue(0xff);
  writeValue(0xb);
  writeEnd();
}
