

void initNeoPixel() {
  pixels.begin();
  pixels.clear();
}

void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<pixels.numPixels(); i++) {
    pixels.setPixelColor(i, c);
    pixels.show();
    delay(wait);
  }
}

void theaterChase(uint32_t c, uint8_t wait) {
  for (int j=0; j<10; j++) {  
    for (int q=0; q < 3; q++) {
      for (uint16_t i=0; i < pixels.numPixels(); i=i+3) {
        pixels.setPixelColor(i+q, c);   
      }
      pixels.show();

      delay(wait);

      for (uint16_t i=0; i < pixels.numPixels(); i=i+3) {
        pixels.setPixelColor(i+q, 0);     
      }
    }
  }
}

void energyExpress(int state){
  if (state == 3) {
    int array[] = {9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26};
    int arraySize = sizeof(array)/sizeof(array[0]);
    pixelArrayCtrl(array, arraySize);
  } else if (state == 2) {
    int array[] = {12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23};
    int arraySize = sizeof(array)/sizeof(array[0]);
    pixelArrayCtrl(array, arraySize);
  } else if (state == 1) {
    int array[] = {15, 16, 17, 18, 19, 20};
    int arraySize = sizeof(array)/sizeof(array[0]);
    pixelArrayCtrl(array, arraySize);
  }
}

void pixelArrayCtrl(int array[], int size) {
  pixels.clear();
  for (int idx=0; idx < size; idx++) {
    pixels.setPixelColor(array[idx], pixels.Color(40, 0, 0));
  }
  pixels.show();
}

void neopixelCtrl(int redList[], int greenList[], int blueList[]) {
  boolean isChange = false;
  for (int i = 0; i < NEOPIXEL_NUM; i++) {
    int r = redList[i];
    int g = greenList[i];
    int b = blueList[i];

    if (r != prevRedList[i] || g != prevGreenList[i] || b != prevBlueList[i]) {
      isChange = true;
      prevRedList[i] = r;
      prevGreenList[i] = g;
      prevBlueList[i] = b;
    }

    if (isChange) {
      uint32_t color = pixels.Color(r, g, b);
      pixels.setPixelColor(i + 9, color);
    }
  }
  if (isChange) {
    pixels.show();
  }
}
